#include "clock.hpp"

#include "flash/flash.hpp"
#include "io/io.hpp"
#include "spi/spi.hpp"
#include "uart/uart.hpp"

#include "eink/eink.hpp"
#include "eink/imagedata.h"

using uart_t = uart::Uart0<>;
REGISTER_UART0_INT_VECTORS(uart_t);

//////////////////////////////////////////////////////////////////////////
int main()
{
	using spi_t = spi::Hardware<spi::Config<>>;

	uart_t serial;
	serial.init();

	sei();

	serial << F("e-Paper demo") << F("\r\n");

	Epd<spi_t, io::P::C1, io::P::C0, io::P::C2> eink;
	eink.Init();

	serial << F("e-Paper init") << F("\r\n");

	serial << F("e-Paper clear") << F("\r\n");
	eink.DisplayClear();

	serial << F("e-Paper draw") << F("\r\n");
	eink.DisplayFrame(IMAGE_BLACK, IMAGE_RED);

	serial << F("e-Paper sleep") << F("\r\n");
	eink.Sleep();

	while (true) {
		serial << F("e-Paper running") << F("\r\n");
		_delay_ms(1000);
	}

	return 0;
}
